/**
 * This script is used to rename the binary with the platform specific postfix.
 * When `tauri build` is ran, it looks for the binary name appended with the platform specific postfix.
 */

const execa = require('execa')
const fs = require('fs')

let extension = ''
if (process.platform === 'win32') {
  extension = '.exe'
}

async function main() {
  const rustInfo = (await execa('rustc', ['-vV'])).stdout
  const targetTriple = /host: (\S+)/g.exec(rustInfo)[1]
  if (!targetTriple) {
    console.error('Failed to determine platform target triple')
  }

  // fs.cpSync('./node_modules/sharp/vendor/lib','./binaries/sharp/vendor/lib', {recursive: true})
  // fs.cpSync('./node_modules/puppeteer/.local-chromium','./binaries/puppeteer', {recursive: true})
  // fs.cpSync('./node_modules/sharp/build/Release','./binaries/sharp/build/Release', {recursive: true})
  fs.rmSync(`../src-tauri/binaries/aptcli-x86_64-apple-darwin`)
  fs.renameSync('build/aptugoclient-macos','../src-tauri/binaries/aptcli-x86_64-apple-darwin')
  // fs.renameSync(
  //   `build`,
  //   `../src-tauri/binaries`
  // )
}

main().catch((e) => {
  throw e
})
