#!/usr/bin/env node
const log = require('./utils/log.js')
const minimist = require('minimist')
const { Server } = require("socket.io")
var http = require('http')
var util = require('util')

process.title = 'Aptugo Command Line Client Server'
function originIsAllowed(origin) {
  return true;
}

function ansiRegex({onlyFirst = false} = {}) {
	const pattern = [
		'[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)',
		'(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-nq-uy=><~]))'
	].join('|');

	return new RegExp(pattern, onlyFirst ? undefined : 'g');
}

function stripAnsi(string) {
	if (typeof string !== 'string') {
		return string
	}
	return string.replace(ansiRegex(), '');
}


module.exports = class socketsServer {
  aptugoClient = null
  wsServer = null

  constructor(aptugoclient) {
    this.aptugoClient = aptugoclient
    this.loadUpServer()
  }

  loadUpServer() {
    const that = this
    const io = new Server({ 
      maxHttpBufferSize: 1e8, // 100Mb,
      cors: {
        origin: ["http://127.0.0.1:3000","tauri://localhost","https://tauri.localhost"],
        methods: ["GET", "POST"]
      }
    })
    io.on('error', () => {
      console.log('un error')
    })
    io.listen(28028)
    this.wsServer = io
    
    io.on("connection", (socket) => {
      log(`Socket connected`, { type: 'title', verbosity: 10 })
      var log_stdout = process.stdout

      console.log = function(d,f = null) { //
        io.emit('feedback', stripAnsi(d))
        log_stdout.write(d + ' ' + f + '\n');
      }
      // // Capture stdout and stderr
      // process.stdout.on('data', (args) => {
      //   io.emit('feedback', args)
      // })


      // const stderrWrite0 = process.stderr.write;
      // process.stderr.write = (args) => {
      //   io.emit('error', args)
      //   return stderrWrite0.apply(process.stderr, args)
      // }

      socket.on('message', (args, callback) => {
        if (args.section && args.section === 'killserver') {
          this.wsServer.close()
        }
        log(`Socket Received message: ${JSON.stringify(args)}`, { verbosity: 10 })
        that.aptugoClient.run(args).then(aptugoClientResponse => {
          log(`Socket Response is: ${JSON.stringify(aptugoClientResponse)}`, { verbosity: 10 })
          callback(aptugoClientResponse)
        //   client.send(JSON.stringify({
        //     id: uuidv4(),
        //     method: 'app.broadcast',
        //     data: {
        //       event: 'aptugoresponse',
        //       data: {
        //         command: e.data,
        //         response: aptugoClientResponse,
        //       }
        //     }
        //   }))
        })
      })
    })
    // var server = http.createServer(function(request, response) {
    //   console.log((new Date()) + ' Received request for ' + request.url)
    //   response.writeHead(404)
    //   response.end()
    // });
    
    // server.listen(28028, function() {
    //   console.log('😝 ----> Listening', (new Date()) + ' Server is listening on port 28028');
    // })
    return 
    // this.wsServer = WebSocketServer(server)

    // this.wsServer.onclose = function() {
    //   log('Connection closed')
    //   process.exit()
    // }
    
    // this.wsServer.on("connection", (socket: Socket) => {      
    //   console.log('socket here', socket)
    
    //   var connection = request.accept()
    //   // var connection = request.accept('echo-protocol', request.origin)
    //   console.log((new Date()) + ' Connection accepted.')
    //   connection.on('message', function(message) {
    //     console.log('😝', 'message', JSON.parse(message.utf8Data))
        
    //     // that.aptugoClient.run(message.utf8Data).then(aptugoClientResponse => {
    //     //   console.log('response is', aptugoClientResponse)
    //     //   client.send(JSON.stringify({
    //     //     id: uuidv4(),
    //     //     method: 'app.broadcast',
    //     //     data: {
    //     //       event: 'aptugoresponse',
    //     //       data: {
    //     //         command: e.data,
    //     //         response: aptugoClientResponse,
    //     //       }
    //     //     }
    //     //   }))
    //     // })
    
    //     return 'hola'
    
    //     // if (message.type === 'utf8') {
    //     //   console.log('Received Message: ' + message.utf8Data)
    //     //   connection.sendUTF(message.utf8Data);
    //     // } else if (message.type === 'binary') {
    //     //   console.log('Received Binary Message of ' + message.binaryData.length + ' bytes')
    //     //   connection.sendBytes(message.binaryData);
    //     // }
    //   })
    
    //   connection.on('close', function(reasonCode, description) {
    //     console.log((new Date()) + ' Peer ' + connection.remoteAddress + ' disconnected.')
    //   })
    // })
  }

  killServer() {
    this.wsServer.close()
  }
}
